version: '3.9'

services:

    tor-router-debian:
        image: tor-router-debian:1.1
        build: 
            context: ./image/tor-router-debian
            # network: host
            # args:
                # HTTP_PROXY: http:/127.0.0.1:8118
                # HTTPS_PROXY: http:/127.0.0.1:8118
                # NO_PROXY: 127.0.0.1,127.0.0.0/8
        restart: always
        healthcheck:
          test: "/bin/bash -c \"if [ ! -f /tmp/health.txt ]; then touch /tmp/health.txt && curl  -S -s --connect-timeout 240 --retry 5 --retry-delay 30 https://check.torproject.org/api/ip | grep :true, || exit 1 ; fi\""
          interval: 30s
          timeout: 10m
          retries: 5
          start_period: 10s
        privileged: true
        cap_add:
            - NET_ADMIN
        # to add scripts will hook startup and permit to launch a command
        # command: sh -c "bash"
        # volumes:
            # - ./image/tor-router-debian/scripts:/root/scripts
      
    client-debian:
        image: tor-router-debian:1.1
        build: 
            context: ./image/tor-router-debian
            # network: host
            # args:
                # HTTP_PROXY: http:/127.0.0.1:8118
                # HTTPS_PROXY: http:/127.0.0.1:8118
                # NO_PROXY: 127.0.0.1,127.0.0.0/8
        depends_on:
            tor-router-debian:
                condition: service_healthy
        network_mode: service:tor-router-debian
        command: sh -c "curl  -S -s https://check.torproject.org/api/ip"
        volumes:
          - ./image/tor-router-debian/scripts:/root/scripts
      
    tor-router:
        image: tor-router:1.0
        build: 
            context: ./image/tor-router
            # network: host
            # args:
                # HTTP_PROXY: http:/127.0.0.1:8118
                # HTTPS_PROXY: http:/127.0.0.1:8118
                # NO_PROXY: 127.0.0.1,127.0.0.0/8
        restart: always
        healthcheck:
          test: "if [ ! -f /tmp/health.txt ]; then touch /tmp/health.txt && curl  -S -s --connect-timeout 240 --retry 5 --retry-delay 30 https://check.torproject.org/api/ip | grep :true, || exit 1 ; else echo \"Health already executed\"; fi"
          interval: 30s
          timeout: 10m
          retries: 5
          start_period: 10s
        privileged: true
        cap_add:
            - NET_ADMIN
        # to add scripts will hook startup and permit to launch a command
        # command: sh -c "bash"
        # volumes:
            # - ./image/tor-router-debian/scripts:/root/scripts

    client:
        image: tor-router:1.0
        build: 
            context: ./image/tor-router
            # network: host
            # args:
                # HTTP_PROXY: http:/127.0.0.1:8118
                # HTTPS_PROXY: http:/127.0.0.1:8118
                # NO_PROXY: 127.0.0.1,127.0.0.0/8
        depends_on:
            tor-router:
                condition: service_healthy
        network_mode: service:tor-router
        command: sh -c "curl  -S -s https://check.torproject.org/api/ip"
        volumes:
            - ./image/tor-router-debian/scripts:/root/scripts

    tor-privoxy:
        restart: always
        build: 
            context: ./image/tor-privoxy
            # network: host
            # args:
                # HTTP_PROXY: http:/127.0.0.1:8118
                # HTTPS_PROXY: http:/127.0.0.1:8118
                # NO_PROXY: 127.0.0.1,127.0.0.0/8
        image: tor-privoxy:1.0
        healthcheck:
          test: "if [ ! -f /tmp/health.txt ]; then touch /tmp/health.txt && curl -x 127.0.0.1:8118 -S -s https://check.torproject.org/api/ip | grep :true, || exit 1 ; else echo \"Health already executed\"; fi"
          interval: 120s
          timeout: 15s
          retries: 2
          start_period: 120s
        ports:
            - "9050:9050" # Tor proxy
            - "9051:9051" # Tor control port
            - "8118:8118" # Privoxy
        expose:
            - 8118
            - 9050
      
    tor-privoxy-debian:
        restart: always
        build: 
            context: ./image/tor-privoxy-debian
            network: host
            args:
                HTTP_PROXY: http:/127.0.0.1:8118
                HTTPS_PROXY: http:/127.0.0.1:8118
                NO_PROXY: 127.0.0.1,127.0.0.0/8
        image: tor-privoxy-debian:1.1
        healthcheck:
          test: "if [ ! -f /tmp/health.txt ]; then touch /tmp/health.txt && curl -x 127.0.0.1:8118 -S -s https://check.torproject.org/api/ip | grep :true, || exit 1 ; else echo \"Health already executed\"; fi"
          interval: 120s
          timeout: 15s
          retries: 2
          start_period: 120s
        ports:
            - "9050:9050" # Tor proxy
            - "9051:9051" # Tor control port
            - "8118:8118" # Privoxy
        expose:
            - 8118
            - 9050
            

